Products
..."
}
}
```
#### Code samples
_Example: Example 1 · HTTP_
```
# This example shows a sample resource applicable for GET (single), PUT, and
# DELETE methods.
https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformer?idOrName=0H0xx0000004ABCAA
```
### PUT Personalization Transformers
`PUT /personalization/external-apps/transformer`
Operation ID: `updateTransformer`. Tags: Personalization Transformers Resources.
The api resource for getting, updating and deleting a single transformer.
Create and update Personalization Transformers.
_Available in: v66.0_
#### Parameters
* `idOrName` (query, string, required)
Unique ID or API name of the personalization transformer to retrieve, update, or delete.
_Available in: v66.0_
#### Request body (required)
Request body for creating or updating a Personalization Transformer.
_Available in: v66.0_
Media type: `application/json`. Schema: `TransformerInput`.
_Example: example\_1_ Payload 1
```
{
"name": "MyTransformer",
"label": "My Transformer",
"description": "Handlebars transformer for web content",
"dataConnectors": [
"connectorId1"
],
"channel": "WebApp",
"isEnabled": true,
"transformerType": "Handlebars",
"substitutionDefinitions": {
"titleKey": {
"label": "Banner title",
"configType": "Static",
"defaultValue": "Welcome",
"overridable": true,
"required": false
}
},
"transformerTypeDetails": {
"html": "
{{content}}
",
"disableAutoInjectionOfEngagementAttributes": false,
"script": "",
"componentName": ""
}
}
```
#### Responses
* **200** _Transformer_ Response body for a single personalization transformer.
Media type: `application/json`. Schema: `Transformer`.
#### Code samples
_Example: Example 1 · HTTP_
```
# This example shows a sample resource applicable for GET (single), PUT, and
# DELETE methods.
https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformer?idOrName=0H0xx0000004ABCAA
Content-Type: application/json
{
"name": "MyTransformer",
"label": "My Transformer",
"description": "Handlebars transformer for web content",
"dataConnectors": [
"connectorId1"
],
"channel": "WebApp",
"isEnabled": true,
"transformerType": "Handlebars",
"substitutionDefinitions": {
"titleKey": {
"label": "Banner title",
"configType": "Static",
"defaultValue": "Welcome",
"overridable": true,
"required": false
}
},
"transformerTypeDetails": {
"html": "
{{content}}
",
"disableAutoInjectionOfEngagementAttributes": false,
"script": "",
"componentName": ""
}
}
```
### DELETE Personalization Transformers
`DELETE /personalization/external-apps/transformer`
Operation ID: `deleteTransformer`. Tags: Personalization Transformers Resources.
The api resource for getting, updating and deleting a single transformer.
Delete Personalization Transformers.
_Available in: v66.0_
#### Parameters
* `idOrName` (query, string, required)
Unique ID or API name of the personalization transformer to retrieve, update, or delete.
_Available in: v66.0_
#### Responses
* **204** _Successful Delete_ Success
#### Code samples
_Example: Example 1 · HTTP_
```
# This example shows a sample resource applicable for GET (single), PUT, and
# DELETE methods.
https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformer?idOrName=0H0xx0000004ABCAA
```
### GET Personalization Transformers Collection
`GET /personalization/external-apps/transformers`
Operation ID: `getTransformers`. Tags: Personalization Transformers Resources.
The api resource for getting and creating transformers.
Get Personalization Transformers.
_Available in: v66.0_
#### Parameters
* `channelType` (query, string) Retrieve only the Personalization Transformers associated with the specified channel.
* `connectorNameOrId` (query, string) Retrieve only the Personalization Transformers associated with the specified DataCloud's StreamingAppDataConnector.
* `dataSpaceIdOrName` (query, string) Id or Name of the DataSpace.
* `isDataConnectorAttached` (query, boolean) Filter transformers by data connector attachment status. When false, returns transformers not attached to any data connector. Can be combined with connectorNameOrId to get transformers matching that connector OR unattached transformers.
* `isEnabled` (query, boolean) Retrieve only the Personalization Transformers which are enabled.
* `limit` (query, integer)
Limits the number of personalization transformers returned. The default is 50 and the value must be between 1 and 299. The list is sorted by name.
_Available in: v66.0_
* `offset` (query, integer)
Number of personalization transformers to skip when retrieving the list. The default is 0 and the value must be between 0 and the number of personalization transformers. The list is sorted by name.
_Available in: v66.0_
* `schemaReference` (query, string) Retrieve only the Personalization Transformers associated with the specified Personalization schema reference.
* `source` (query, string)
Source of the personalization transformers to retrieve. Values: `{Global}` , `{Organization}` . Default is `{Organization}` .
_Available in: v66.0_
* `transformerCategory` (query, string) Retrieve only the Personalization Transformers associated with the specified Personalization Transformer Category.
* `transformerType` (query, TransformerTypeEnum) Retrieve only the Personalization Transformers associated with the specified transformer type.
#### Responses
* **200** _Transformer Collection_ Response body for list of personalization transformers.
Media type: `application/json`. Schema: `TransformerCollection`.
_Example: example\_1_ Transformer Collection
```
{
"totalSize": 2,
"transformers": [
{
"id": "0H0xx0000004ABCAA",
"name": "MyTransformer",
"label": "My Transformer",
"description": "Sample transformer",
"isEnabled": true,
"channel": "WebApp"
}
],
"currentPageUrl": "https://yourInstance.salesforce.com/services/data/v66.0/personalization/external-apps/transformers?limit=50&offset=0",
"nextPageUrl": null
}
```
#### Code samples
_Example: Example 1 · HTTP_
```
# This example shows a sample resource applicable for GET (collection) and POST
# methods.
https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformers?limit=50&offset=0&source=Organization
```
### POST Personalization Transformers
`POST /personalization/external-apps/transformers`
Operation ID: `createTransformers`. Tags: Personalization Transformers Resources.
The api resource for getting and creating transformers.
Create Personalization Transformers.
_Available in: v66.0_
#### Request body
Request body for creating or updating a Personalization Transformer.
Media type: `application/json`. Schema: `TransformerInput`.
_Example example\_1: same as PUT /personalization/external-apps/transformer request._ Payload 1
_Example: example\_1_ Payload 1
#### Responses
* **200** _Transformer_ Response body for a single personalization transformer.
Media type: `application/json`. Schema: `Transformer`.
#### Code samples
_Example: Example 1 · HTTP_
```
# This example shows a sample resource applicable for GET (collection) and POST
# methods.
https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformers?limit=50&offset=0&source=Organization
Content-Type: application/json
{
"name": "MyTransformer",
"label": "My Transformer",
"description": "Handlebars transformer for web content",
"dataConnectors": [
"connectorId1"
],
"channel": "WebApp",
"isEnabled": true,
"transformerType": "Handlebars",
"substitutionDefinitions": {
"titleKey": {
"label": "Banner title",
"configType": "Static",
"defaultValue": "Welcome",
"overridable": true,
"required": false
}
},
"transformerTypeDetails": {
"html": "
{{content}}
",
"disableAutoInjectionOfEngagementAttributes": false,
"script": "",
"componentName": ""
}
}
```
## Schemas
### ABnExperimentInput
ABn Experiment Input Representation
* `chanceToWinThreshold` (_number (double)_)
Winning threshold (85.00–100.00).
_Available in: v65.0_
* `cohorts` (_array of array of PersonalizationAttributeValueInput_, required)
List of ABn Experiment Cohorts.
_Available in: v65.0_
* `criteria` (_string_)
JSON defining targeting or segmentation rules.
_Available in: v65.0_
* `dataSpaceName` (_string_, required)
The API name of the personalization point's data space.
_Available in: v65.0_
* `description` (_string_)
An optional description for the experiment.
_Available in: v65.0_
* `label` (_string_, required)
The experiment's UI label.
_Available in: v65.0_
* `maximumDurationInMinutes` (_integer_)
Maximum duration in minutes (min: `minimumDurationInMinutes` , max: 129600). Ignored if `winnerSelectionMode` is manual.
_Available in: v65.0_
* `minimumDurationInMinutes` (_integer_)
Minimum duration in minutes (60–129600). Ignored if `winnerSelectionMode` is manual.
_Available in: v65.0_
* `minimumRequiredParticipants` (_integer_)
Minimum required participants (300–5000). Ignored if `winnerSelectionMode` is manual.
_Available in: v65.0_
* `name` (_string_, required)
The experiment's API name.
_Available in: v65.0_
* `parameters` (_array of ParameterValueInput_)
Required engagement signal parameters.
_Available in: v65.0_
* `primaryMetrics` (_array of PrimaryMetricReferenceInput_)
Primary metrics for evaluating experiment performance and success.
_Available in: v65.0_
* `profileDataGraphName` (_string_)
The API name of the profile data graph.
_Available in: v65.0_
* `scheduleFrequencyInMinutes` (_integer_)
Processing frequency in minutes (30–1440).
_Available in: v65.0_
* `schemaEnum` (_PersonalizationSchemaEnum_)
* `schemaName` (_string_, required)
API name of the personalization schema. The data space prefix must match `dataSpaceName` .
_Available in: v65.0_
* `secondaryMetrics` (_array of MetricReferenceInput_)
Metrics for additional performance and behavior insights.
_Available in: v65.0_
* `source` (_object_, required)
PersonalizationSourceEnum
The Experiment’s source.
_Available in: v65.0_
Includes all fields of `PersonalizationSourceEnum`.
* `sourceRecordId` (_string_)
Reference to the origin record, such as a Flow. Generates an edit link when combined with the source enum.
_Available in: v65.0_
* `winnerSelectionMode` (_object_)
WinnerSelectionModeEnum
Winner selection mode: automatic or manual.
_Available in: v65.0_
Includes all fields of `WinnerSelectionModeEnum`.
### ABnExperiment
Contains details of a personalization Experiment.
**Note**: This representation inherits properties from Personalization Experiment Named Base.
* `chanceToWinThreshold` (_number (double)_) Threshold used to declare a winner
* `cohorts` (_array of ABnExperimentCohort_)
The list of experiment cohorts.
_Available in: v65.0_
* `createdById` (_string (Id)_) Created by id
* `createdDate` (_string (date-time)_) Created date
* `criteria` (_object_)
Criteria
Targeting and segmentation rules.
_Available in: v65.0_
Includes all fields of `Criteria`.
* `dataSpaceName` (_string_)
The API name of the experiment's data space.
_Available in: v65.0_
* `description` (_string_) Experiment description
* `id` (_string (Id)_) The 18 character ID of the record
* `isRemote` (_boolean_) Is Remote
* `label` (_string_) Personalization base output label
* `lastAnalyzed` (_string (date-time)_) When the experiment was last analyzed
* `lastModifiedById` (_string (Id)_) Last modified by id
* `lastModifiedDate` (_string (date-time)_) Last modified date
* `maximumDurationInMinutes` (_integer_) Maximum duration of the experiment in minutes
* `minimumDurationInMinutes` (_integer_) Minimum duration of the experiment in minutes
* `minimumRequiredParticipants` (_integer_) Minimum number of participants required for each cohort
* `name` (_string_) Personalization base output API name
* `parameters` (_array of ParameterValue_) List of Parameters associated with the Experiment
* `primaryMetric` (_object_)
PersonalizationExperimentMetricReference
Primary metric for evaluating experiment performance.
_Available in: v65.0_
Includes all fields of `PersonalizationExperimentMetricReference`.
* `primaryMetrics` (_array of PrimaryMetricReference_) The primary metrics of this experiment
* `profileDataGraphName` (_string_)
The API name of the profile data graph.
_Available in: v65.0_
* `scheduleFrequencyInMinutes` (_integer_) How frequently the experiment analytics should be processed
* `schemaEnum` (_PersonalizationSchemaEnum_)
* `schemaName` (_string_)
The API name of the personalization schema. If the name includes a data space prefix, it must match `dataSpaceName` .
_Available in: v65.0_
* `secondaryMetrics` (_array of MetricReference_)
Metrics for additional performance and behavior insights.
_Available in: v65.0_
* `source` (_object_)
PersonalizationSourceEnum
The Experiment's source.
_Available in: v65.0_
Includes all fields of `PersonalizationSourceEnum`.
* `sourceRecordId` (_string_) A record which created this Experiment and which is responsible for maintaining it. What type of object this is depends on the Source.
* `sourceReferenceId` (_string (Id)_)
Reference to the origin record. Generates an edit link when combined with the source enum.
_Available in: v65.0_
* `startedDate` (_string (date-time)_)
The date and time the experiment started.
_Available in: v65.0_
* `state` (_object_)
ExperimentStateEnum
The Experiment's state.
_Available in: v65.0_
Includes all fields of `ExperimentStateEnum`.
* `status` (_object_)
EntityStatusEnum
The Experiment's status.
_Available in: v65.0_
Includes all fields of `EntityStatusEnum`.
* `stoppedDate` (_string (date-time)_)
The date and time the experiment stopped.
_Available in: v65.0_
* `url` (_string (url)_) Url
* `winnerSelectionMode` (_WinnerSelectionModeEnum_)
### BatchDecisionCollection
Personalization Batch Decision Collection Output Representation
* `batchDecisions` (_array of BatchDecision_) List of personalization batch decisions
* `currentPageUrl` (_string (url)_) Current page url
* `nextPageUrl` (_string (url)_) Next page url if it exists
* `totalSize` (_integer_) Total size of collection
### BatchDecisionInput
Personalization Batch Decision Input Representation
* `activationTriggerType` (_PersonalizationBatchDecisionActivationTriggerTypeEnum_)
* `batchStatus` (_PersonalizationBatchDecisionStatusEnum_)
* `dataSpaceName` (_string_) The API name of the Data Space associated with the Personalization Batch Decision
* `description` (_string_) Personalization Base description
* `label` (_string_) Personalization Base label
* `marketSegmentName` (_string_) The API name of the market segment associated with the Personalization Batch Decision
* `name` (_string_) Personalization Point API name
* `personalizationKeyFields` (_array of PersonalizationFieldTypeEnum_) The list of key field types associated with the Personalization Batch Decision
* `personalizationPointNames` (_array of string_) The list of personalization point API names associated with the Personalization Batch Decision
* `refreshMode` (_DataExportRefreshModeEnum_)
### BatchDecision
Personalization Batch Decision Output Representation
* `activationTriggerType` (_PersonalizationBatchDecisionActivationTriggerTypeEnum_)
* `batchStatus` (_PersonalizationBatchDecisionStatusEnum_)
* `createdById` (_string (Id)_) Created by id
* `createdDate` (_string (date-time)_) Created date
* `dataSpace` (_PersonalizationReference_)
* `description` (_string_) Personalization Batch Decision description
* `id` (_string (Id)_) The 18 character ID of the record
* `inputDataModelObject` (_PersonalizationReference_)
* `isRemote` (_boolean_) Is Remote
* `label` (_string_) Personalization base output label
* `lastModifiedById` (_string (Id)_) Last modified by id
* `lastModifiedDate` (_string (date-time)_) Last modified date
* `lastRefreshDate` (_string (date-time)_) When the job last ran off-core
* `lastRefreshErrorCode` (_PersonalizationBatchDecisionErrorCodeOffCoreEnum_)
* `lastRefreshStatus` (_PersonalizationBatchDecisionLastRefreshStatusEnum_)
* `lastSuccessfulRefreshDate` (_string (date-time)_) Last successful refreshed date that happened off-core
* `marketSegment` (_PersonalizationReference_)
* `modelRevision` (_integer_) Model revision increases everytime batch decision is updated
* `name` (_string_) Personalization base output API name
* `outputDataModelObject` (_PersonalizationReference_)
* `personalizationKeyFields` (_array of PersonalizationFieldTypeEnum_) List of personalization key field types associated with personalization batch decision
* `personalizationPoints` (_array of string_) List of API names of personalization points associated with personalization batch decision
* `refreshMode` (_DataExportRefreshModeEnum_)
* `status` (_EntityStatusEnum_)
* `url` (_string (url)_) Url
### BatchDecisionPatchInput
Personalization Batch Decision Patch Input Representation
* `batchStatus` (_PersonalizationBatchDecisionStatusEnum_)
* `description` (_string_) Personalization Base description
* `label` (_string_) Personalization Base label
* `name` (_string_) Personalization Point API name
* `runBatchPersonalization` (_boolean_) Flag to determine whether to run batch personalization
### BatchDecisionJobCollection
Batch Decision Job Collection Output Representation
* `currentPageUrl` (_string (url)_) URL of the current page
* `jobs` (_array of BatchDecisionJob_) List of jobs
* `lastEvaluatedKey` (_string_) Last evaluated key. Pass this value to receive the next page.
* `nextPageUrl` (_string (url)_) URL of the next page, or null if there is no next page
### CalculatedAffinityCollection
Calculated Affinity Collection Output Representation
* `calculatedAffinities` (_array of CalculatedAffinity_) List of calculated affinities
* `currentPageUrl` (_string (url)_) Current page url
* `nextPageUrl` (_string (url)_) Next page url if it exists
* `totalSize` (_integer_) Total size of collection
### CalculatedAffinityInput
Calculated Affinity Input Representation
* `contentObjectFieldNames` (_array of string_) The Content Object field names to compare this calculated affinity model against
* `contentObjectName` (_string_) The name of the Content Object
* `dataSpaceName` (_string_) The API name of the Data Space associated with this affinity
* `description` (_string_) Personalization Base description
* `engagementSignals` (_array of CalculatedAffinityEngagementSignalInput_) A collection of user interactions with their strength and impact, such as product views and purchases, used to determine a user's affinity for specific brands or products, with more recent and purchase-related engagements contributing higher to the affinity score
* `isDecay` (_boolean_) Whether decay is enabled
* `label` (_string_) Personalization Base label
* `lookBackWindow` (_integer_) The time frame in days the model should consider when computing affinity
* `name` (_string_) Personalization Point API name
* `profileDataGraphName` (_string_) The name of the Profile Data Graph
* `scoringModel` (_ScoringModelEnum_)
### CalculatedAffinity
Calculated Affinity Output Representation
* `contentObjectFieldNames` (_array of string_) The field names of the Content Object used to compare affinity against
* `contentObjectName` (_string_) The name of the Content Object
* `createdById` (_string (Id)_) Created by id
* `createdDate` (_string (date-time)_) Created date
* `dataSpaceName` (_string_) The API name of the Data Space associated with the Calculated Affinity
* `description` (_string_) Description of the Calculated Affinity
* `engagementSignals` (_array of CalculatedAffinityEngagementSignal_) The interaction signals with their strength and impact used for computing affinity
* `id` (_string (Id)_) The 18 character ID of the record
* `isDecay` (_boolean_) Whether decay is enabled
* `label` (_string_) Personalization base output label
* `lastModifiedById` (_string (Id)_) Last modified by id
* `lastModifiedDate` (_string (date-time)_) Last modified date
* `lookBackWindow` (_integer_) The time frame in days the model should consider when computing affinity
* `name` (_string_) Personalization base output API name
* `profileDataGraphName` (_string_) The name of the Profile Data Graph
* `scoringModel` (_ScoringModelEnum_)
* `url` (_string (url)_) Url
### PersonalizationExperienceConfigCollection
Personalization Experience Config Collection Output Representation
* `currentPageUrl` (_string (url)_) Current page url
* `nextPageUrl` (_string (url)_) Next page url if it exists
* `personalizationExperienceConfigs` (_array of PersonalizationExperienceConfig_) List of Personalization Experience Configs
* `totalSize` (_integer_) Total size of collection
### PersonalizationExperienceConfigInput
Personalization Experience Config Input Representation
* `createdById` (_string_) Id of the user who created this Personalization Experience Config (read-only, ignored on input)
* `createdDate` (_string (date-time)_) The datetime when this Personalization Experience Config was created (read-only, ignored on input)
* `dataProvider` (_DataProviderInput_)
* `description` (_string_) Description of the Personalization Experience Config
* `displayUrl` (_string_) When editing this configuration on the Website which page of the website should this configuration be displayed on if not the current page.
* `id` (_string_) Id of the Personalization Experience Config (read-only, ignored on input)
* `isEnabled` (_boolean_) Whether or not this particular configuration is enabled.
* `label` (_string_) Label of the Personalization Experience Config
* `lastModifiedById` (_string_) Id of the user who last modified this Personalization Experience Config (read-only, ignored on input)
* `lastModifiedDate` (_string (date-time)_) The datetime when this Personalization Experience Config was last modified.
* `name` (_string_) Name of the Personalization Experience Config
* `publishedDate` (_string (date-time)_) The datetime when this Personalization Experience Config was last published.
* `sourceMatchers` (_array of SourceMatcherInput_) How to find the source where this personalization will occur which for web is which web pages.
* `transformationConfig` (_array of TransformationInput_) How will the data provided by the Data Provider be transformed?
### PersonalizationExperienceConfig
Personalization Experience Config Output Representation
* `createdById` (_string (Id)_) Id of the user who created this Personalization Experience Config
* `createdDate` (_string (date-time)_) The datetime when this Personalization Experience Config was created.
* `dataProvider` (_DataProvider_)
* `description` (_string_) Description of the Personalization Experience Config
* `displayUrl` (_string_) When editing this configuration on the Website which page of the website should this configuration be displayed on if not the current page.
* `id` (_string (Id)_) Id of the Personalization Experience Config
* `isEnabled` (_boolean_) Whether or not this particular configuration is enabled.
* `label` (_string_) Label of the Personalization Experience Config
* `lastModifiedById` (_string (Id)_) Id of the user who last modified this Personalization Experience Config
* `lastModifiedDate` (_string (date-time)_) The datetime when this Personalization Experience Config was last modified.
* `name` (_string_) Name of the Personalization Experience Config
* `publishedDate` (_string (date-time)_) The datetime when this Personalization Experience Config was last published.
* `sourceMatchers` (_array of SourceMatcher_) How to find the source where this personalization will occur which for web is which web pages.
* `transformationConfig` (_TransformationConfig_)
* `wpmUrl` (_string (url)_) Customer website URL with authURL and wpm parameter as query param
### PersonalizationPointInput
This representation defines the settings for creating or updating a personalization point.
* `abnExperimentName` (_string_)
API name of a Personalization Experiment that the personalization point is part of.
_Available in: v65.0_
* `dataSpaceName` (_string_)
API name of the data space where this personalization point resides.
_Available in: v64.0_
* `decisions` (_array of PersonalizationDecisionInput_)
List of personalization decision definitions.
_Available in: v64.0_
* `description` (_string_)
Optional description of the personalization point.
_Available in: v64.0_
* `isAuthenticationRequired` (_boolean_)
Whether the end user must be authenticated at runtime. Defaults to false prior to v66.0.
_Available in: v66.0_
* `label` (_string_)
Display label that appears in the user interface.
_Available in: v64.0_
* `maxItemsCount` (_integer_)
Maximum number of content items to return at runtime. Defaults to 12 for recommendation type personalization content schemas.
_Available in: v64.0_
* `name` (_string_)
API name of the personalization point.
_Available in: v64.0_
* `profileDataGraphName` (_string_)
API name of the profile data graph for this personalization point. This value is optional unless decisions use targeting rules that reference profile attributes.
_Available in: v64.0_
* `rootPersonalizationPointId` (_string_)
ID of the root Personalization Point (for derived points).
_Available in: v64.0_
* `schemaName` (_string_)
API name of a personalization content schema assigned to this personalization point. You can use this field, or the schemaEnum, but not both.
_Available in: v64.0_
* `sourceRecordId` (_string_)
ID of the record responsible for maintaining this personalization point.
_Available in: v64.0_
* `schemaEnum` (_object_)
Standard personalization content schema type. Use this string, or the schemaName, but not both.
_Available in: v64.0_
Includes all fields of `PersonalizationSchemaEnum`.
* `source` (_object_)
Application used to create this personalization point.
_Available in: v64.0_
Includes all fields of `PersonalizationSourceEnum`.
### PersonalizationPoint
Contains detailed output information for a personalization point.
* `abnExperimentName` (_string_)
API name of a personalization experiment that the personalization point is part of.
_Available in: v65.0_
* `createdById` (_string (Id)_)
ID of the user who created the personalization point.
_Available in: v64.0_
* `createdDate` (_string (date-time)_)
Timestamp of when the personalization point was created.
_Available in: v64.0_
* `dataSpaceName` (_string_)
API name of the data space where this personalization point resides.
_Available in: v64.0_
* `decisions` (_array of PersonalizationDecision_)
List of personalization decision definitions.
_Available in: v64.0_
* `description` (_string_)
Optional description of the personalization point.
_Available in: v64.0_
* `id` (_string (Id)_)
Salesforce personalization point record ID.
_Available in: v64.0_
* `isAuthenticationRequired` (_boolean_)
Whether authentication is required at runtime.
_Available in: v66.0_
* `label` (_string_)
Display label that appears for the personalization point in the user interface.
_Available in: v64.0_
* `lastModifiedById` (_string (Id)_)
ID of the user who last modified the record.
_Available in: v64.0_
* `lastModifiedDate` (_string (date-time)_)
Timestamp of when the personalization point was last modified.
_Available in: v64.0_
* `maxItemsCount` (_integer_)
Maximum number of personalized content items returned at runtime.
_Available in: v64.0_
* `name` (_string_)
API name of the personalization point.
_Available in: v64.0_
* `profileDataGraphName` (_string_)
API name of the profile data graph for this personalization point.
_Available in: v64.0_
* `rootPersonalizationPointId` (_string_)
ID of the root personalization point (for derived points).
_Available in: v64.0_
* `schemaName` (_string_)
API name of the personalization content schema assigned to this personalization point.
_Available in: v64.0_
* `sourceRecordId` (_string_)
ID of the record responsible for maintaining this personalization point.
_Available in: v64.0_
* `url` (_string (url)_)
The relative path to the server for this resource (for example, /services/data/v67.0/personalization/personalization-points/{name}).
_Available in: v64.0_
* `schemaEnum` (_object_)
Standard personalization schema type, if applicable.
_Available in: v64.0_
Includes all fields of `PersonalizationSchemaEnum`.
* `source` (_object_)
Application used to create this personalization point.
_Available in: v64.0_
Includes all fields of `PersonalizationSourceEnum`.
* `status` (_object_)
Status of the personalization point.
_Available in: v64.0_
Includes all fields of `EntityStatusEnum`.
### PersonalizationRecommenderCollection
Contains a collection of personalization recommenders.
* `data` (_array of PersonalizationRecommender_)
A collection of personalization recommenders.
_Available in: v64.0_
### PersonalizationRecommenderInput
Contains the details for creating a personalization recommender.
**Note**: This representation inherits properties from the Personalization Recommender Base Input.
* `backupRecommenderName` (_string_) The API name (developerName) of the backup recommender to use when primary recommender returns insufficient recommendation results.
* `chanceToLoseThreshold` (_number (double)_) Threshold used to declare a losing variant.
* `chanceToWinThreshold` (_number (double)_) Threshold used to declare a winning variant.
* `dataSpaceName` (_string_, required)
The name of the data space for the recommender.
_Available in: v64.0_
* `decisionOptions` (_array of PersonalizationRecommenderDecisionOptionInput_) Decision options (arms) of this contextual bandit recommender.
* `description` (_string_) Personalization Base description
* `excludeFilters` (_array of BaseRuleInput_)
The exclusion filters for the recommender.
_Available in: v64.0_
* `includeFilters` (_array of BaseRuleInput_)
The inclusion filters for the recommender.
_Available in: v64.0_
* `itemDataGraphName` (_string_, required)
The name of the item data graph for the recommender.
_Available in: v64.0_
* `label` (_string_) Personalization Base label
* `minimumRequiredParticipants` (_integer_) Minimum number of participants required for evaluation.
* `name` (_string_) Personalization Point API name
* `objectiveName` (_string_)
The custom objective for the recommender.
_Available in: v64.0_
* `profileDataGraphName` (_string_, required)
The name of the profile data graph for the recommender.
_Available in: v64.0_
* `scheduleFrequencyInMinutes` (_integer_) How frequently recommender analytics should be processed, in minutes.
* `sortCriteria` (_object_)
PersonalizationRecommenderSortCriteria
The sort order for rule-based recommenders.
_Available in: v64.0_
Includes all fields of `PersonalizationRecommenderSortCriteria`.
* `sourceRecordId` (_string (Id)_) The FlowRecordElement or ManagedContent record that owns or created this recommender.
* `state` (_RecommenderStateEnum_)
### PersonalizationRecommender
Contains details of a personalization recommender.
**Note**: This representation inherits properties from Personalization Recommender Named Base.
* `backupRecommender` (_PersonalizationReference_)
* `chanceToLoseThreshold` (_number (double)_) Threshold used to declare a losing variant.
* `chanceToWinThreshold` (_number (double)_) Threshold used to declare a winning variant.
* `contentObject` (_object_)
PersonalizationReference
The content object used by the recommender.
_Available in: v64.0_
Includes all fields of `PersonalizationReference`.
* `createdById` (_string (Id)_) Created by id
* `createdDate` (_string (date-time)_) Created date
* `dataSpace` (_object_)
PersonalizationReference
The data space used by the recommender.
_Available in: v64.0_
Includes all fields of `PersonalizationReference`.
* `decisionOptions` (_array of PersonalizationRecommenderDecisionOption_) Decision options (arms) of this contextual bandit recommender. Returned only on filter=Big.
* `excludeFilters` (_object_)
RuleGroup
The exclusion filter for the recommender.
_Available in: v64.0_
Includes all fields of `RuleGroup`.
* `id` (_string (Id)_) The 18 character ID of the record
* `includeFilters` (_object_)
RuleGroup
The inclusion filter for the recommender.
_Available in: v64.0_
Includes all fields of `RuleGroup`.
* `isRemote` (_boolean_) Indicates if the recommender is remote.
* `itemDataGraph` (_object_)
PersonalizationReference
The item data graph used by the recommender.
_Available in: v64.0_
Includes all fields of `PersonalizationReference`.
* `label` (_string_) Personalization base output label
* `lastModifiedById` (_string (Id)_) Last modified by id
* `lastModifiedDate` (_string (date-time)_) Last modified date
* `lastRefreshedStatus` (_object_)
LatestRefreshedStatusEnum
The status of the last refresh.
_Available in: v64.0_
Includes all fields of `LatestRefreshedStatusEnum`.
* `lastSuccessfulRefresh` (_string (date-time)_)
The time when the last successful refresh happened.
_Available in: v64.0_
* `minimumRequiredParticipants` (_integer_) Minimum number of participants required for evaluation.
* `name` (_string_) Personalization base output API name
* `objective` (_object_)
PersonalizationReference
The objective of the recommender.
_Available in: v64.0_
Includes all fields of `PersonalizationReference`.
* `profileDataGraph` (_object_)
PersonalizationReference
The profile data graph used by the recommender.
_Available in: v64.0_
Includes all fields of `PersonalizationReference`.
* `scheduleFrequencyInMinutes` (_integer_) How frequently recommender analytics should be processed, in minutes.
* `sortCriteria` (_object_)
SortCriteria
The sort criteria for the recommender.
_Available in: v64.0_
Includes all fields of `SortCriteria`.
* `sourceRecordId` (_string (Id)_) The FlowRecordElement or ManagedContent record that owns or created this recommender.
* `state` (_RecommenderStateEnum_)
* `status` (_object_)
EntityStatusEnum
The status of the recommender.
_Available in: v64.0_
Includes all fields of `EntityStatusEnum`.
* `url` (_string (url)_) Url
### PersonalizationRecommenderPatchInput
Contains the details for editing a personalization recommender.
**Note**: This representation inherits properties from the Personalization Recommender Base Patch Input.
* `backupRecommenderName` (_string_) The API name (developerName) of the backup recommender to use when primary recommender returns insufficient recommendation results.
* `chanceToLoseThreshold` (_number (double)_) Threshold used to declare a losing variant.
* `chanceToWinThreshold` (_number (double)_) Threshold used to declare a winning variant.
* `decisionOptions` (_array of PersonalizationRecommenderDecisionOptionInput_) Decision options (arms) of this contextual bandit recommender. Reconciles by name: matched options are updated, unmatched incoming options are created, unmatched existing options are deleted (cascade).
* `description` (_string_) Description of the entity.
* `excludeFilters` (_array of BaseRuleInput_)
The filters applied before rendering recommendations to decide items to exclude.
_Available in: v65.0_
* `includeFilters` (_array of BaseRuleInput_)
The filters applied before rendering recommendations to decide items to include.
_Available in: v65.0_
* `label` (_string_) Label of the entity.
* `minimumRequiredParticipants` (_integer_) Minimum number of participants required for evaluation.
* `scheduleFrequencyInMinutes` (_integer_) How frequently recommender analytics should be processed, in minutes.
* `state` (_RecommenderStateEnum_)
### PersonalizationRecommenderJobCollection
Contains a collection of personalization recommender jobs.
* `currentPageUrl` (_string (url)_)
The URL for the current page of results.
_Available in: v63.0_
* `jobs` (_array of PersonalizationRecommenderJob_)
A collection of personalization recommender jobs.
_Available in: v63.0_
* `nextPageUrl` (_string (url)_)
The URL for the next page of results, if one exists.
_Available in: v63.0_
### PersonalizationSchemaInput
Contains the details for creating or updating a personalization content schema.
* `attributes` (_array of PersonalizationAttributeInput_)
List of personalization attributes associated with the content schema.
_Available in: v65.0_
* `dataSpaceName` (_string_)
The API name of the data space associated with the personalization content schema.
_Available in: v65.0_
* `description` (_string_)
A description of the personalization content schema.
_Available in: v65.0_
* `label` (_string_)
The display label for the personalization content schema.
_Available in: v65.0_
* `name` (_string_)
The API name of the personalization content schema.
_Available in: v65.0_
* `relatedContentObjects` (_array of PersonalizationRelatedContentObjectInput_)
List of related content objects. These are DMOs related to the primary content object whose fields are also included in the runtime response.
_Available in: v65.0_
* `personalizationType` (_object_)
The type of the personalization schema.
_Available in: v65.0_
Includes all fields of `PersonalizationTypeEnum`.
* `contentObject` (_object_)
Information about the content DMO fields returned as content at runtime.
_Available in: v65.0_
Includes all fields of `PersonalizationContentObjectInput`.
### PersonalizationSchema
Contains details of a personalization content schema.
* `attributes` (_array of PersonalizationAttribute_)
List of personalization attributes associated with the schema.
_Available in: v65.0_
* `createdById` (_string (Id)_)
The ID of the user who created the personalization content schema.
_Available in: v65.0_
* `createdDate` (_string (date-time)_)
The date and time when the personalization content schema was created.
_Available in: v65.0_
* `dataSpaceName` (_string_)
The API name of the data space associated with the personalization content schema.
_Available in: v65.0_
* `description` (_string_)
A description of the personalization content schema.
_Available in: v65.0_
* `id` (_string (Id)_)
The unique identifier for the personalization content schema.
_Available in: v65.0_
* `label` (_string_)
The display label for the personalization content schema.
_Available in: v65.0_
* `lastModifiedById` (_string (Id)_)
The ID of the user who last modified the personalization content schema.
_Available in: v65.0_
* `lastModifiedDate` (_string (date-time)_)
The date and time when the personalization content schema was last modified.
_Available in: v65.0_
* `name` (_string_)
The API name of the personalization content schema.
_Available in: v65.0_
* `relatedContentObjects` (_array of PersonalizationRelatedContentObject_)
List of related content objects.
_Available in: v65.0_
* `url` (_string (url)_)
The API URL for this personalization content schema resource.
_Available in: v65.0_
* `personalizationType` (_object_)
The type of the personalization content schema.
_Available in: v65.0_
Includes all fields of `PersonalizationTypeEnum`.
* `contentObject` (_object_)
The content object information.
_Available in: v65.0_
Includes all fields of `PersonalizationContentObject`.
### EngagementSignalCompoundMetricInput
Engagement Signal Compound Metric Input Representation
* `denominatorMetric` (_object_, required)
EngagementSignalMetricFieldInput
The Engagement Signal Metric used as the secondary operand.
_Available in: v64.0_
Includes all fields of `EngagementSignalMetricFieldInput`.
* `description` (_string_)
Description of the compound metric.
_Available in: v64.0_
* `label` (_string_, required)
Label for the compound metric.
_Available in: v64.0_
* `name` (_string_, required)
API name for the compound metric.
_Available in: v64.0_
* `numeratorMetric` (_object_, required)
EngagementSignalMetricFieldInput
The Engagement Signal Metric used as the primary operand.
_Available in: v64.0_
Includes all fields of `EngagementSignalMetricFieldInput`.
* `operator` (_object_, required)
EngagementSignalCompoundMetricOperatorEnum
Operator between the two metrics.
_Available in: v64.0_
Includes all fields of `EngagementSignalCompoundMetricOperatorEnum`.
### EngagementSignalCompoundMetric
Response body for an Engagement Signal Compound Metric.
* `denominatorMetric` (_object_)
EngagementSignalMetricField
The Engagement Signal Metric used as the secondary operand.
_Available in: v64.0_
_Filter group: Small_
Includes all fields of `EngagementSignalMetricField`.
* `description` (_string_)
Description of the compound metric.
_Available in: v64.0_
_Filter group: Small_
* `id` (_string (Id)_)
ID of the compound metric.
_Available in: v64.0_
_Filter group: Small_
* `label` (_string_)
Label for the compound metric.
_Available in: v64.0_
_Filter group: Small_
* `name` (_string_)
API name for the compound metric.
_Available in: v64.0_
_Filter group: Small_
* `numeratorMetric` (_object_)
EngagementSignalMetricField
The Engagement Signal Metric used as the primary operand.
_Available in: v64.0_
_Filter group: Small_
Includes all fields of `EngagementSignalMetricField`.
* `operator` (_object_)
EngagementSignalCompoundMetricOperatorEnum
Operator between the two metrics.
_Available in: v64.0_
_Filter group: Small_
Includes all fields of `EngagementSignalCompoundMetricOperatorEnum`.
* `createdById` (_string (Id)_)
Created by ID of the Compound Metric.
_Available in: v64.0_
_Filter group: Small_
* `createdDate` (_string (date)_)
Creation date of the Compound Metric.
_Available in: v64.0_
_Filter group: Small_
* `lastModifiedById` (_string (Id)_)
Last modified ID of the Compound Metric.
_Available in: v64.0_
_Filter group: Small_
* `lastModifiedDate` (_string (date)_)
Last modified date of the Compound Metric.
_Available in: v64.0_
_Filter group: Small_
* `url` (_string_)
Connect URL to this resource.
_Available in: v64.0_
_Filter group: Small_
### EngagementSignalCollection
List of Engagement Signals.
This representation extends `CdpPaginatedResponseBaseRepresentation`. For inherited pagination fields, see [Paginated Response Base Output](https://developer.salesforce.com/docs/data/connectapi/references/spec?meta=type%3APaginated%2BResponse%2BBase%2BOutput).
* `currentPageUrl` (_string (url)_) Current page url
* `engagementSignals` (_array of EngagementSignal_)
List of Engagement Signals.
_Available in: v63.0_
_Filter group: Small_
* `nextPageUrl` (_string (url)_) Next page url if it exists
* `totalSize` (_integer_) Total size of collection
### EngagementSignalInput
Engagement Signal Input Representation
* `catalogIdField` (_object_)
FieldInput
A field on the content object DMO or its related DMO.
_Available in: v63.0_
Includes all fields of `FieldInput`.
* `compoundMetrics` (_array of EngagementSignalCompoundMetricInput_) Engagement Signal Compound Metrics
* `dataSpaceName` (_string_, required)
The API name of the Data Space associated with the Engagement Signal.
_Available in: v63.0_
* `description` (_string_) Engagement Signal description
* `distinctFields` (_array of FieldInput_)
Fields on the content object DMO or its related DMOs.
_Available in: v63.0_
* `filterGroups` (_array of EngagementSignalFilterGroupInput_)
Engagement Signal Filter Group Collection.
_Available in: v63.0_
* `joinDimensions` (_array of EngagementSignalJoinDimDefInput_) Engagement Signal Join Dimension Definitions
* `label` (_string_, required)
The label of the Engagement Signal.
_Available in: v63.0_
* `metrics` (_array of EngagementSignalMetricInput_)
Engagement Signal Metrics.
_Available in: v63.0_
* `name` (_string_, required)
The API name of the Engagement Signal.
_Available in: v63.0_
* `objectName` (_string_, required)
The API name of the Content Object DMO with the Engagement Signal.
_Available in: v63.0_
* `parameters` (_array of EngagementSignalParameterInput_)
Engagement Signal Parameters.
_Available in: v63.0_
* `timestampField` (_object_, required)
FieldInput
DateTime field on the content object DMO or its related DMO.
_Available in: v63.0_
Includes all fields of `FieldInput`.
* `uniqueIdentifier` (_FieldInput_)
* `userIdField` (_object_, required)
FieldInput
A field on the content object DMO or its related DMO.
_Available in: v63.0_
Includes all fields of `FieldInput`.
* `uniqueIdentifierField` (_object_, required)
EngagementSignalField
A field on the content object DMO or its related DMO.
_Available in: v63.0_
Includes all fields of `EngagementSignalField`.
### EngagementSignal
Response body for an Engagement Signal.
* `catalogIdField` (_object_)
Field
A field on the content object DMO or its related DMO.
_Available in: v63.0_
_Filter group: Small_
Includes all fields of `Field`.
* `compoundMetrics` (_array of EngagementSignalCompoundMetric_) Engagement Signal Compound Metrics
* `dataSpaceName` (_string_)
The API name of the Data Space associated with the Engagement Signal.
_Available in: v63.0_
_Filter group: Small_
* `description` (_string_) Engagement Signal Description
* `distinctFields` (_array of Field_)
Fields on the content object DMO or its related DMOs.
_Available in: v63.0_
_Filter group: Big_
* `filterGroups` (_array of EngagementSignalFilterGroup_)
List of filter groups.
_Available in: v63.0_
_Filter group: Big_
* `id` (_string (Id)_)
The platform object ID of the Engagement Signal.
_Available in: v63.0_
_Filter group: Small_
* `joinDimensions` (_array of EngagementSignalJoinDimDef_) Engagement Signal Join Dimension Definitions
* `label` (_string_)
The label of the Engagement Signal.
_Available in: v63.0_
_Filter group: Small_
* `metrics` (_array of EngagementSignalMetric_)
List of metrics.
_Available in: v63.0_
_Filter group: Medium_
* `name` (_string_)
The API name of the Engagement Signal.
_Available in: v63.0_
_Filter group: Small_
* `objectName` (_string_)
The API name of the Content Object associated with the Engagement Signal.
_Available in: v63.0_
_Filter group: Small_
* `parameters` (_array of EngagementSignalParameter_)
List of parameters.
_Available in: v63.0_
_Filter group: Medium_
* `timestampField` (_object_)
Field
DateTime field on the content object DMO or its related DMO.
_Available in: v63.0_
_Filter group: Small_
Includes all fields of `Field`.
* `uniqueIdentifier` (_object_)
Field
A field on the content object DMO or its related DMO.
_Available in: v63.0_
_Filter group: Small_
Includes all fields of `Field`.
* `userIdField` (_object_)
Field
A field on the content object DMO or its related DMO.
_Available in: v63.0_
_Filter group: Small_
Includes all fields of `Field`.
### EngagementSignalMetricInput
Request body for creating an Engagement Signal Metric.
* `aggregateFunction` (_object_, required)
EngagementSignalMetricAggregateFunctionEnum
Engagement Signal Metric Aggregate Function. The value can be
* SUM
* AVG
* COUNT
* DISTINCT
_Available in: v64.0_
Includes all fields of `EngagementSignalMetricAggregateFunctionEnum`.
* `description` (_string_) Engagement Signal Metric description
* `field` (_object_, required)
EngagementSignalField
A field on the content object DMO or its related DMO for the metric calculation.
_Available in: v64.0_
Includes all fields of `EngagementSignalField`.
* `label` (_string_) Engagement Signal Metric label
* `name` (_string_, required)
The name of the Engagement Signal Metric.
_Available in: v64.0_
### EngagementSignalMetric
Response body for an Engagement Signal Metric.
* `aggregateFunction` (_object_)
EngagementSignalMetricAggregateFunctionEnum
Engagement Signal Metric Aggregate Function Enum.
_Available in: v64.0_
_Filter group: Small_
Includes all fields of `EngagementSignalMetricAggregateFunctionEnum`.
* `field` (_object_)
Field
A field on the content object DMO or its related DMO for the metric calculation.
_Available in: v64.0_
_Filter group: Small_
Includes all fields of `Field`.
* `id` (_string (Id)_)
ID of the Engagement Signal Metric.
_Available in: v64.0_
_Filter group: Small_
* `name` (_string_)
The name of the Engagement Signal Metric.
_Available in: v64.0_
_Filter group: Small_
### Transformer
Response body for a single personalization transformer.
* `channel` (_object_)
StreamingAppDataConnectorTypeEnum
Specifies whether this transformer is for a website or mobile application. Values are: `{MobileApp}` , `{WebApp}` .
_Available in: v66.0_
_Filter group: Small_
Includes all fields of `StreamingAppDataConnectorTypeEnum`.
* `createdById` (_string_)
ID of the user or process that created this object.
_Available in: v66.0_
_Filter group: Small_
* `createdDate` (_string (date-time)_)
Timestamp when the object was created.
_Available in: v66.0_
_Filter group: Small_
* `dataConnectors` (_array of StreamingAppDataConnector_)
List of websites or mobile apps this personalization transformer belongs to.
_Available in: v66.0_
_Filter group: Small_
* `dataSpace` (_string_)
Name of the data space the transformer belongs to.
_Available in: v66.0_
_Filter group: Small_
* `description` (_string_)
Description of the object.
_Available in: v66.0_
_Filter group: Small_
* `id` (_string_)
Unique identifier for the object.
_Available in: v66.0_
_Filter group: Small_
* `isEnabled` (_boolean_)
Defines the enablement status of the transformer when delivered to the mobile app or website.
_Available in: v66.0_
_Filter group: Small_
* `label` (_string_)
Human-readable label or title for the object.
_Available in: v66.0_
_Filter group: Small_
* `lastModifiedById` (_string_)
ID of the user or process that last modified this object.
_Available in: v66.0_
_Filter group: Small_
* `lastModifiedDate` (_string (date-time)_)
Timestamp of the most recent update to the object.
_Available in: v66.0_
_Filter group: Small_
* `name` (_string_)
Internal name of the object.
_Available in: v66.0_
_Filter group: Small_
* `publishedDate` (_string (date-time)_)
Date and time when the transformer was last published to the mobile app or website.
_Available in: v66.0_
_Filter group: Small_
* `schemaReference` (_string_)
Specifies the name of the response template, if the transformer substitution definitions were created referencing one.
_Available in: v66.0_
_Filter group: Small_
* `substitutionDefinitions` (_object_)
Object keyed by the substitution name. Each value matches Substitution Details.
_Available in: v66.0_
_Filter group: Small_
Additional properties: `SubstitutionDetails`.
* `thumbnailImage` (_string_) Thumbnail image for this Transformer (can be a URL or base64-encoded data).
* `transformerCategory` (_object_)
TransformerCategoryEnum
Defines the way this transformer is used. Values are: `{EmbeddedContent}` , `{Agent}` .
_Available in: v66.0_
_Filter group: Small_
Includes all fields of `TransformerCategoryEnum`.
* `transformerType` (_object_)
TransformerTypeEnum
Instruction to the SDK on how the transformer works. Values are: `{Handlebars}` , `{HtmlElementModifier}` , `{AgentScript}` , `{Component}` .
_Available in: v66.0_
_Filter group: Small_
Includes all fields of `TransformerTypeEnum`.
* `transformerTypeDetails` (_object_)
TransformerDetails
Data specific to the type of transformer.
_Available in: v66.0_
_Filter group: Small_
Includes all fields of `TransformerDetails`.
### TransformerInput
Request body for creating or updating a Personalization Transformer.
* `channel` (_object_)
StreamingAppDataConnectorTypeEnum
Specifies whether this ttransformer is for a website or mobile application. Values are: `{MobileApp}` , `{WebApp}` .
_Available in: v66.0_
Includes all fields of `StreamingAppDataConnectorTypeEnum`.
* `dataConnectors` (_array of string_)
List of websites or mobile apps this personalization transformer belongs to. This can be `{id}` , `{name}` , `{appSourceId}` , or `{Data360 StreamingAppDataConnector}` .
_Available in: v66.0_
* `dataSpace` (_string_) The Name of the Dataspace the Transformer belongs to.
* `description` (_string_)
Description of the object.
_Available in: v66.0_
* `isEnabled` (_boolean_)
Specifies whether this transformer is enabled when delivered to the mobile app or website.
_Available in: v66.0_
* `label` (_string_)
Human-readable label or title for the object.
_Available in: v66.0_
* `name` (_string_, required)
Unique name of the object.
_Available in: v66.0_
* `schemaReference` (_string_)
If the Transformer Substitution Definitions were created referencing a response template, the name of that template.
_Available in: v66.0_
* `substitutionDefinitions` (_object_)
Object added by substitution name. Each value matches the substitution variable input.
_Available in: v66.0_
Additional properties: `SubstitutionInputDetails`.
* `thumbnailImage` (_string_) Thumbnail image for this Transformer (can be a URL or base64-encoded data).
* `transformerType` (_object_)
TransformerTypeEnum
Instruction to the SDK on how the transformer works. Values are: `{Handlebars}` , `{HtmlElementModifier}` , `{AgentScript}` , `{Component}` .
_Available in: v66.0_
Includes all fields of `TransformerTypeEnum`.
* `transformerTypeDetails` (_object_)
TransformerTypeDetails
Data specific to the type of transformer.
_Available in: v66.0_
Includes all fields of `TransformerTypeDetails`.
### TransformerTypeEnum
Instruction to the SDK on how the Transformer will work and what SDK code to use when rendering Transformer
Type: `string`.
Allowed values: `AgentScript`, `Component`, `Handlebars`, `HtmlElementModifier`.
### TransformerCollection
Response body for list of personalization transformers.
* `currentPageUrl` (_string (url)_)
URL to the current page of transformers.
_Available in: v66.0_
_Filter group: Small_
* `nextPageUrl` (_string (url)_)
URL to the next page of transformers if there are more pages.
_Available in: v66.0_
_Filter group: Small_
* `totalSize` (_integer_)
Total number of transformers.
_Available in: v66.0_
_Filter group: Small_
* `transformers` (_array of Transformer_)
List of transformers. Each item matches the Transformer response body.
_Available in: v66.0_
_Filter group: Small_
### PersonalizationAttributeValueInput
This representation defines a custom attribute value. The attributeName and attributeEnum values are mutually exclusive. The value string has a maximum length of 20,000 characters. Attribute values must be unique within a decision. All merge field handlebar references in the value must correspond to declared merge fields.
* `attributeName` (_string_)
API name of a custom attribute. Use this if the personalization point has a custom personalization schema.
_Available in: v61.0_
* `mergeFields` (_array of PersonalizationMergeFieldInput_)
List of merge fields embedded in this attribute value.
_Available in: v66.0_
* `value` (_string_)
The value to assign.
_Available in: v61.0_
* `attributeEnum` (_object_)
Standard attribute set. Use this if the personalization point's schema is identified by an enum.
_Available in: v61.0_
Includes all fields of `PersonalizationAttributeEnum`.
### ParameterValueInput
Experiment Parameter Value Input Representation
* `engagementSignalName` (_string_) Developer name of the engagement signal this parameter belongs to
* `parameterName` (_string_) Developer name of the parameter
* `values` (_array of string_) List of parameter values
### PrimaryMetricReferenceInput
A reference to a metric used as a primary metric in AbnExperiments
* `engagementSignalName` (_string_) Developer name of the metric’s parent
* `higherIsBetter` (_boolean_) Indicates whether a higher value for the metric is better
* `metricName` (_string_) Developer name of the metric
* `metricType` (_MetricTypeEnum_)
* `overallScoreWeight` (_integer_) Number between 1 and 10000 (basis points) indicating the weight of the metric
### PersonalizationSchemaEnum
Standard Personalization Schemas
Type: `string`.
Allowed values: `DecisionDefined`, `ExperienceVariation`, `FlowPath`.
### MetricReferenceInput
A reference to a metric used in Input Representations
* `engagementSignalName` (_string_) Developer name of the metric’s parent
* `higherIsBetter` (_boolean_) Indicates whether a higher value for the metric is better
* `metricName` (_string_) Developer name of the metric
* `metricType` (_MetricTypeEnum_)
### PersonalizationSourceEnum
Personalization Source values
Type: `string`.
Allowed values: `Agentforce`, `BlockBuilder`, `ExperienceBuilder`, `FlowBuilder`, `PersonalizationApp`, `PersonalizationCampaign`.
### WinnerSelectionModeEnum
Winner Selection Mode values
Type: `string`.
Allowed values: `Automatic`, `Manual`.
### ABnExperimentCohort
ABn Experiment Cohort Output Representation
* `allocationWeight` (_integer_) Number between 0 and 10000 (basis points) for traffic percent allocation
* `attributeValues` (_array of PersonalizationAttributeValue_) Personalization Attribute Values associated with a Cohort
* `createdById` (_string (Id)_) Created by id
* `createdDate` (_string (date-time)_) Created date
* `id` (_string (Id)_) The 18 character ID of the record
* `isControl` (_boolean_) Whether or not this is the control Cohort
* `isFallThrough` (_boolean_) Whether the control cohort should use the existing experience (the personalization decisions on the personalization point) as the control cohort.
* `label` (_string_) Personalization base output label
* `lastModifiedById` (_string (Id)_) Last modified by id
* `lastModifiedDate` (_string (date-time)_) Last modified date
* `name` (_string_) Personalization base output API name
* `personalizerName` (_string_) The API name of the Personalizer associated with a Cohort
* `url` (_string (url)_) Url
### Criteria
Personalization Decision Criteria Output Representation
* `filters` (_array of Filter_) Filters
* `operator` (_string_) Operator
* `type` (_string_) Type
### ParameterValue
Experiment Parameter Value Output Representation
* `engagementSignalName` (_string_) Developer name of the engagement signal this parameter belongs to
* `parameterName` (_string_) Developer name of the parameter
* `values` (_array of string_) List of parameter values
### PersonalizationExperimentMetricReference
Defines the metrics for additional performance and behavior insights.
* `metricType` (_object_)
PersonalizationExperimentMetricTypeEnumRequest
The metric's entity type.
_Available in: v65.0_
Includes all fields of `PersonalizationExperimentMetricTypeEnumRequest`.
* `name` (_string_)
Reference to a child record in `[ParentName.name]` format.
_Available in: v65.0_
* `metricName` (_string_)
The metric's developer name.
_Available in: v65.0_
* `engagementSignalName` (_string_)
Developer name of the metric’s parent.
_Available in: v65.0_
* `HigherIsBetter` (_boolean_)
Indicates if a higher metric value is better.
_Available in: v65.0_
### PrimaryMetricReference
A reference to a metric used as a primary metric in AbnExperiments
* `engagementSignalName` (_string_) Developer name of the metric’s parent
* `higherIsBetter` (_boolean_) Indicates whether a higher value for the metric is better
* `metricName` (_string_) Developer name of the metric
* `metricType` (_MetricTypeEnum_)
* `overallScoreWeight` (_integer_) Number between 1 and 10000 (basis points) indicating the weight of the metric
### MetricReference
A reference to a metric used in Output Representations
* `engagementSignalName` (_string_) Developer name of the metric’s parent
* `higherIsBetter` (_boolean_) Indicates whether a higher value for the metric is better
* `metricName` (_string_) Developer name of the metric
* `metricType` (_MetricTypeEnum_)
### ExperimentStateEnum
Experiment state
Type: `string`.
Allowed values: `Archived`, `Created`, `Started`, `Stopped`.
### EntityStatusEnum
Entity Status values
Type: `string`.
Allowed values: `Active`, `CreateError`, `DeleteError`, `Deleting`, `EditError`, `Preparing`, `Processing`.
### PersonalizationBatchDecisionActivationTriggerTypeEnum
The type of activation trigger type for a personalization batch decision.
Type: `string`.
Allowed values: `Automatic`, `None`.
### PersonalizationBatchDecisionStatusEnum
It shows the live status of a personalization batch decision.
Type: `string`.
Allowed values: `Active`, `Error`, `Paused`.
### PersonalizationFieldTypeEnum
It shows the field Type of personalization batch decision key field.
Type: `string`.
Allowed values: `Email`, `MobilePush`, `Sms`.
### DataExportRefreshModeEnum
Refresh type of the activation.
Type: `string`.
Allowed values: `Full_Refresh`, `Incremental`.
### PersonalizationReference
Personalization Reference Representation
* `label` (_string_) Personalization Reference label
* `name` (_string_) Personalization Reference API name
### PersonalizationBatchDecisionErrorCodeOffCoreEnum
The error code from off-core (Process Object Service).
Type: `string`.
Allowed values: `ConfigurationMissingError`, `InternalError`, `ModelValidationError`, `None`.
### PersonalizationBatchDecisionLastRefreshStatusEnum
The status of the last refresh with off-core (Process Object Service).
Type: `string`.
Allowed values: `Canceled`, `Complete`, `Failure`, `None`, `Processing`.
### BatchDecisionJob
Batch Decision Job Output Representation
* `batchDecisionAudienceSize` (_integer_) The batch decision audience size
* `batchDecisionName` (_string_) The batch decision name
* `batchDecisionsMade` (_integer_) The number of batch decisions made
* `errorCode` (_string_) The error code if the job fails
* `errorMessage` (_string_) The error message if the job fails
* `lastRunStatus` (_PersonalizationBatchDecisionLastRefreshStatusEnum_)
* `refreshMode` (_DataExportRefreshModeEnum_)
* `refreshStart` (_string_) The refresh start time
* `refreshUpdated` (_string_) The refresh updated time
* `statusId` (_string_) The status ID
### CalculatedAffinityEngagementSignalInput
Calculated Affinity Engagement Signal Input Representation
* `engagementSignalName` (_string_) The API name (Developer Name) of the Engagement Signal
* `impact` (_EngagementSignalImpactEnum_)
* `strength` (_EngagementSignalStrengthEnum_)
### ScoringModelEnum
Scoring Model for Calculated Affinity
Type: `string`.
Allowed values: `Objective`, `Simple`.
### CalculatedAffinityEngagementSignal
Engagement Signal Output Representation
* `engagementSignal` (_string_) The Engagement Signal ID
* `impact` (_EngagementSignalImpactEnum_)
* `strength` (_EngagementSignalStrengthEnum_)
### DataProviderInput
Personalization Experience Config Data Provider Input Representation
* `dataSpaceReferenceType` (_ReferenceEnum_)
* `dataSpaceValue` (_string_) The unique identifier of the Data Space. Optional, to override default. If DataSpaceReferenceType is ApiName then this would be Data Space's API Name.
* `groupByReferenceType` (_ReferenceEnum_)
* `groupByType` (_DataProviderGroupByEnum_)
* `groupByValue` (_string_) The unique identifier of the Grouping By Value. Optional, to override default. If GroupByReferenceType is ApiName then this would be Group By's API Name.
* `referenceType` (_ReferenceEnum_)
* `type` (_DataProviderEnum_)
* `value` (_string_) The unique identifier of the Data Provider. If ReferenceType is ApiName then this would be Data Provider's API Name.
### SourceMatcherInput
Personalization Experience Config Source Matcher Input Representation
* `type` (_SourceMatcherEnum_)
* `value` (_string_) Contents depends on SourceMatcherType. If SourceMatcherType.PageType then this will be a specific Page Type from the Site Map. If SourceMatcherType.PageUrlMatcher then this will be a Page URL which supports wildcards.
### TransformationInput
Personalization Experience Config Transformation Input Representation
* `name` (_string_) The name of the Content Zone.
* `path` (_string_) Path to the Element
* `substitutionValues` (_object_) When a Transformer supports Substitution Definitions, then this will be the mapping of the Value to the Definition. The Data Type of the Value will need to conform to the Definition's Data Type.
Additional properties: `object`.
* `tag` (_string_) The tag of element (e.g. div, img, etc.)
* `transformerName` (_string_) The name of the transformer to use for the transformation.
### DataProvider
Personalization Experience Config Data Provider Output Representation
* `dataSpaceReferenceType` (_ReferenceEnum_)
* `dataSpaceValue` (_string_) The unique identifier of the Data Space. Optional, to override default. If DataSpaceReferenceType is ApiName then this would be Data Space's API Name.
* `groupByReferenceType` (_ReferenceEnum_)
* `groupByType` (_DataProviderGroupByEnum_)
* `groupByValue` (_string_) The unique identifier of the Grouping By Value. Optional, to override default. If GroupByReferenceType is ApiName then this would be Group By's API Name.
* `referenceType` (_ReferenceEnum_)
* `type` (_DataProviderEnum_)
* `value` (_string_) The unique identifier of the Data Provider. If ReferenceType is ApiName then this would be Data Provider's API Name.
### SourceMatcher
Personalization Experience Config Source Matcher Output Representation
* `type` (_SourceMatcherEnum_)
* `value` (_string_) Contents depends on SourceMatcherType. If SourceMatcherType.PageType then this will be a specific Page Type from the Site Map. If SourceMatcherType.PageUrlMatcher then this will be a Page URL which supports wildcards.
### TransformationConfig
Personalization Experience Config Transformation Config Output Representation
* `engagementDestination` (_string_) If provided this will need to map to a specific destination entry in the Engagement config which would determine the Event Attributes needed to land the data in Data Cloud with the necessary attributes to correctly map this into the target Engagement Destination Data Model Object (DMO).
* `method` (_TargetMethodEnum_)
* `renderIfEmpty` (_boolean_) Should we render the content from the transformation if it couldn't be transformed? Default if missing is not to render.
* `transformations` (_array of Transformation_) How will the Data Provider Response be transformed into acceptable content.
* `when` (_TransformationConfigWhenEnum_)
* `whenValues` (_WhenValues_)
### PersonalizationDecisionInput
This representation defines a decision within a personalization point. Decision names must be unique within a personalization point. For decision-defined schemas, the personalizer name is required. The personalizer (recommender) must be active, and its content schema must match the personalization point's content schema.
* `name` (_string_)
API name of the decision.
_Available in: v61.0_
* `label` (_string_)
Display label that appears in the user interface.
_Available in: v61.0_
* `description` (_string_)
Optional description for the decision.
_Available in: v61.0_
* `personalizerName` (_string_)
API name of the personalizer (recommender) associated with this decision.
_Available in: v61.0_
* `targetingRules` (_object_)
Targeting rules applied to this decision. If no targeting rules are created, the decision applies unconditionally (no audience filtering).
_Available in: v67.0_
Includes all fields of `RuleGroup`.
* `state` (_object_)
Lifecycle state of the decision.
_Available in: v62.0_
Includes all fields of `DecisionStateEnum`.
* `attributeValues` (_array of PersonalizationAttributeValueInput_)
List of personalization attribute values.
_Available in: v61.0_
### PersonalizationDecision
Contains detailed output information of a personalization decision.
* `attributeValues` (_array of PersonalizationAttributeValue_)
List of personalization attribute values.
_Available in: v61.0_
* `createdById` (_string (Id)_)
ID of the user who created the record.
_Available in: v62.0_
* `createdDate` (_string (date-time)_)
Decision creation timestamp.
_Available in: v62.0_
* `description` (_string_)
Optional description for the decision.
_Available in: v61.0_
* `id` (_string (Id)_)
Decision record ID.
_Available in: v62.0_
* `label` (_string_)
Display label for the decision.
_Available in: v61.0_
* `lastModifiedById` (_string (Id)_)
ID of the user who last modified the decision.
_Available in: v62.0_
* `lastModifiedDate` (_string (date-time)_)
Last modification timestamp.
_Available in: v62.0_
* `name` (_string_)
API name of the decision.
_Available in: v61.0_
* `personalizerName` (_string_)
API name of the associated personalizer. For example, the recommender name.
_Available in: v61.0_
* `url` (_string (url)_) Url
* `targetingRules` (_object_)
List of targeting rules.
_Available in: v67.0_
Includes all fields of `RuleGroup`.
* `state` (_object_)
Lifecycle state of the decision.
_Available in: v62.0_
Includes all fields of `DecisionStateEnum`.
### PersonalizationRecommenderDecisionOptionInput
Personalization Recommender Decision Option Input Representation
* `attributeValues` (_array of PersonalizationAttributeValueInput_) Attribute values associated with this decision option.
* `description` (_string_) Personalization Base description
* `label` (_string_) Personalization Base label
* `name` (_string_) Personalization Point API name
* `personalizerName` (_string_) The API name of a chained-bandit recommender this option points to. The referenced recommender must already exist.
### BaseRuleInput
The base representation for a recommender rule input.
* `type` (_RuleTypeEnum_, required)
### PersonalizationRecommenderSortCriteria
Defines the sort criteria for rule-based recommenders.
* `calculatedInsightName` (_string_, required)
The API name of the calculated insight.
_Available in: v64.0_
* `metricName` (_string_)
The name of the metric of the calculated insight.
_Available in: v64.0_
* `sortOrder` (_object_, required)
PersonalizationRecommenderSortOrderEnumRequest
The order of the items being returned based on the metric value.
_Available in: v64.0_
Includes all fields of `PersonalizationRecommenderSortOrderEnumRequest`.
* `calculatedInsightMetricName` (_string_, required)
The API name of the metric of the calculated insight.
_Available in: v64.0_
### RecommenderStateEnum
Recommender lifecycle state
Type: `string`.
Allowed values: `Draft`, `Live`.
### PersonalizationRecommenderDecisionOption
Personalization Recommender Decision Option Output Representation
* `attributeValues` (_array of PersonalizationAttributeValue_) Attribute values associated with this decision option.
* `createdById` (_string (Id)_) Created by id
* `createdDate` (_string (date-time)_) Created date
* `description` (_string_) The description of the decision option.
* `id` (_string (Id)_) The 18 character ID of the record
* `label` (_string_) Personalization base output label
* `lastModifiedById` (_string (Id)_) Last modified by id
* `lastModifiedDate` (_string (date-time)_) Last modified date
* `name` (_string_) Personalization base output API name
* `personalizer` (_PersonalizationReference_)
* `url` (_string (url)_) Url
### RuleGroup
Rule Group Representation
* `operator` (_LogicalOperatorEnum_)
* `rules` (_array of BaseRule_) The filter conditions of the recommender.
* `type` (_RuleTypeEnum_)
### LatestRefreshedStatusEnum
Enum values for the recommender last refresh status.
Type: `string`.
Allowed values: `Complete`, `Failure`, `None`, `Processing`.
### SortCriteria
Personalization Recommender sort criteria Representation
* `calculatedInsightLabel` (_string_) The label of the calculated insight.
* `calculatedInsightMetricLabel` (_string_) The label of the metric of CI.
* `sortOrder` (_SortOrderEnum_)
### PersonalizationRecommenderJob
Contains the details of a personalization recommender job.
* `errorCode` (_string_)
The error code returned if the job fails.
_Available in: v63.0_
* `errorMessage` (_string_)
The error message returned if the job fails.
_Available in: v63.0_
* `startTime` (_string_)
The start time of the job.
_Available in: v63.0_
* `status` (_object_)
PersonalizationRecommenderJobStatusEnum
The current status of the job.
_Available in: v63.0_
Includes all fields of `PersonalizationRecommenderJobStatusEnum`.
* `updatedTime` (_string_)
The time when the job was last updated.
_Available in: v63.0_
* `version` (_string_)
The version of the job.
_Available in: v63.0_
### PersonalizationAttributeInput
Defines a group of personalization attributes associated with the personalization content schema.
* `defaultValue` (_string_)
Default value used when no decision-specific value is assigned.
_Available in: v65.0_
* `label` (_string_)
The display label for the personalization attribute.
_Available in: v65.0_
* `name` (_string_)
The API name of the attribute.
_Available in: v65.0_
### PersonalizationRelatedContentObjectInput
Defines a group of related personalization content objects.
* `contentObjectName` (_string_)
The API name of the related content object.
_Available in: v67.0_
* `fieldNames` (_array of string_)
List of DMO field API names to include from this related object.
_Available in: v67.0_
* `relatedContentObjects` (_array of PersonalizationRelatedContentObjectInput_)
List of nested RelatedContentObjectInput objects (for multi-hop relationships).
_Available in: v67.0_
### PersonalizationTypeEnum
Personalization Types
Type: `string`.
Allowed values: `ExperienceVariation`, `FlowPath`, `ManualContent`, `Recommendations`.
### PersonalizationContentObjectInput
Defines the content object used for the personalization.
* `fieldNames` (_array of string_)
List of DMO field API names to include in the runtime response. Only these fields are returned as content.
_Available in: v65.0_
* `name` (_string_)
The API name of the content DMO used for the personalization.
_Available in: v65.0_
### PersonalizationAttribute
Defines the response information for a group of personalization attributes associated with the personalization content schema.
* `createdById` (_string (Id)_)
The ID of the user who created the record.
_Available in: v62.0_
* `createdDate` (_string (date-time)_)
The date and time when the attribute was created.
_Available in: v62.0_
* `defaultValue` (_string_)
Default value of the attribute.
_Available in: v65.0_
* `id` (_string (Id)_)
Salesforce record ID of the attribute.
_Available in: v62.0_
* `label` (_string_)
The display label of the attribute.
_Available in: v65.0_
* `lastModifiedById` (_string (Id)_)
The ID of the user who last modified the attribute.
_Available in: v62.0_
* `lastModifiedDate` (_string (date-time)_)
The date and time when the attribute was last modified.
_Available in: v62.0_
* `name` (_string_)
The API name of the attribute.
_Available in: v65.0_
* `url` (_string (url)_)
The API URL for this resource.
_Available in: v62.0_
### PersonalizationRelatedContentObject
Defines the response information for a group of related personalization content objects.
* `contentObjectLabel` (_string_)
The display label of the related content object.
_Available in: v67.0_
* `contentObjectName` (_string_)
The API name of the related content object.
_Available in: v67.0_
* `fields` (_array of PersonalizationContentObjectField_)
List of ContentObjectField objects. Each object contains an API name and label string.
_Available in: v67.0_
* `relatedContentObjects` (_array of PersonalizationRelatedContentObject_)
List of nested RelatedContentObjectOutput objects (recursive).
_Available in: v67.0_
### PersonalizationContentObject
Defines the content object response information for the personalization.
* `fields` (_array of PersonalizationContentObjectField_) List of DMO Fields
* `label` (_string_)
The display label of the content object.
_Available in: v65.0_
* `name` (_string_)
The API name of the content object.
_Available in: v65.0_
### EngagementSignalMetricFieldInput
References an Engagement Signal Metric by Engagement Signal and Metric names.
* `engagementSignalMetricName` (_string_, required)
API name of the Engagement Signal Metric.
_Available in: v64.0_
* `engagementSignalName` (_string_, required)
API name of the Engagement Signal.
_Available in: v64.0_
### EngagementSignalCompoundMetricOperatorEnum
Operator between the two metrics.
_Available in: v64.0_
_Filter group: Small_
Type: `string`.
Allowed values: `Ratio`.
### EngagementSignalMetricField
Output representation for a Engagement Signal Metric field
* `engagementSignalMetricName` (_string_) Name of the Engagement Signal Metric
* `engagementSignalName` (_string_) Name of the Engagement Signal
### FieldInput
Input representation for a field
* `name` (_string_) Name of the field
* `objectName` (_string_) DMO name of the field
### EngagementSignalFilterGroupInput
A group of Engagement Signal filters with a conjunctive operator.
* `conjunctiveOperator` (_object_, required)
EngagementSignalFilterGroupConditionEnum
Operator to combine the filters in this group. The value can be
_Available in: v63.0_
Includes all fields of `EngagementSignalFilterGroupConditionEnum`.
* `filters` (_array of EngagementSignalFilterInput_, required)
List of filters.
_Available in: v63.0_
### EngagementSignalJoinDimDefInput
Engagement Signal Join Dim Def Input Representation
* `relatedDmoName` (_string_) The related DMO for this Join Dimension Definition
* `relationshipId` (_string_) A FieldSrcTrgtRelationship ID for this Join Dimension Definition
* `relationshipPathOrder` (_integer_) A relationship path order for this Join Dimension Definition
### EngagementSignalParameterInput
Parameter definition used in Engagement Signal input.
* `field` (_object_, required)
FieldInput
A field on the content object DMO or its related DMO.
_Available in: v63.0_
Includes all fields of `FieldInput`.
* `label` (_string_, required)
The label of the parameter.
_Available in: v63.0_
* `name` (_string_, required)
The name of the parameter.
_Available in: v63.0_
* `operator` (_object_, required)
EngagementSignalFilterOperatorEnum
Filter operator for the parameter. The value can be
_Available in: v63.0_
Includes all fields of `EngagementSignalFilterOperatorEnum`.
* `required` (_boolean_, required)
Whether a value is required for this parameter.
_Available in: v63.0_
### EngagementSignalField
Field input object.
* `name` (_string_, required)
Field name.
_Available in: v63.0_
_Filter group: Small_
* `objectName` (_string_, required)
Object name of the field.
_Available in: v63.0_
_Filter group: Small_
* `label` (_string_)
Field label.
_Available in: v63.0_
_Filter group: Small_
### Field
Output representation for a field
* `dataType` (_string_) Data type of the field
* `label` (_string_) Label of the field
* `name` (_string_) Name of the field
* `objectName` (_string_) DMO name of the field
### EngagementSignalFilterGroup
Group of Engagement Signal filters.
* `conjunctiveOperator` (_object_)
EngagementSignalFilterGroupConditionEnum
Conjunctive operator for the filter group.
_Available in: v63.0_
_Filter group: Small_
Includes all fields of `EngagementSignalFilterGroupConditionEnum`.
* `filters` (_array of EngagementSignalFilter_)
List of Engagement Signal Filters.
_Available in: v63.0_
_Filter group: Small_
### EngagementSignalJoinDimDef
Engagement Signal Join Dim Def Representation
* `relatedDmoName` (_string_) Engagement Signal Related DMO Name
* `relationship` (_Relationship_)
* `relationshipPathOrder` (_integer_) Engagement Signal Relationship Path Order
### EngagementSignalParameter
Parameter definition in an Engagement Signal.
* `field` (_object_)
Field
A field on the content object DMO or its related DMO.
_Available in: v63.0_
_Filter group: Small_
Includes all fields of `Field`.
* `label` (_string_)
The label of the parameter.
_Available in: v63.0_
_Filter group: Small_
* `name` (_string_)
The name of the parameter.
_Available in: v63.0_
_Filter group: Small_
* `operator` (_object_)
EngagementSignalFilterOperatorEnum
Filter operator for the parameter.
_Available in: v63.0_
_Filter group: Small_
Includes all fields of `EngagementSignalFilterOperatorEnum`.
* `required` (_boolean_)
Whether a value is required for this parameter.
_Available in: v63.0_
_Filter group: Small_
### EngagementSignalMetricAggregateFunctionEnum
Engagement Signal Metric Aggregate Function. The value can be
* SUM
* AVG
* COUNT
* DISTINCT
_Available in: v64.0_
Type: `string`.
Allowed values: `Average`, `Count`, `Distinct`, `Select`, `Sum`.
### StreamingAppDataConnectorTypeEnum
Type of application connector. Values are: `{MobileApp}` , `{WebApp}` .
_Available in: v66.0_
_Filter group: Small_
Type: `string`.
Allowed values: `MobileApp`, `WebApp`.
### StreamingAppDataConnector
Connection information for a streaming app data connector in a transformer response.
* `appIdentifier` (_string_)
Unique UUID generated for the connector.
_Available in: v66.0_
_Filter group: Small_
* `id` (_string_)
Unique id for the connector.
_Available in: v66.0_
_Filter group: Small_
* `name` (_string_)
Unique name for the connector.
_Available in: v66.0_
_Filter group: Small_
* `streamingAppDataConnectorType` (_object_)
StreamingAppDataConnectorTypeEnum
Type of application connector. Values are: `{MobileApp}` , `{WebApp}` .
_Available in: v66.0_
_Filter group: Small_
Includes all fields of `StreamingAppDataConnectorTypeEnum`.
### SubstitutionDetails
Substitution variable details in a transformer response.
* `configType` (_object_)
PersonalizationSubstitutionDefConfigTypeEnum
Specifies how the substitution variable can be interpreted. Values are: `{SchemaPath}` , `{Static}` .
_Available in: v66.0_
_Filter group: Small_
Includes all fields of `PersonalizationSubstitutionDefConfigTypeEnum`.
* `defaultValue` (_string_)
Default value for the substitution definition to be used if personalization experience does not override the value.
_Available in: v66.0_
_Filter group: Small_
* `description` (_string_)
Description to be displayed on the UI when configuring this substitution variable.
_Available in: v66.0_
_Filter group: Small_
* `label` (_string_)
Label to be displayed on the UI when configuring this substitution variable.
_Available in: v66.0_
_Filter group: Small_
* `overridable` (_boolean_)
Specifies whether the experience can override the default value.
_Available in: v66.0_
_Filter group: Small_
* `required` (_boolean_)
Specifies whether a value (either default or in an experience) must be provided.
_Available in: v66.0_
_Filter group: Small_
### TransformerCategoryEnum
How will this Transformer be used.
Type: `string`.
Allowed values: `Agent`, `EmbeddedContent`.
### TransformerDetails
Data specific to the type of transformer
* `componentName` (_string_)
A name the Component (which for now is Mobile) developer provides to indicate which Component Class in the Application will do the rendering. Web version of this if desired could be the name of a React Component class
_Available in: v66.0_
_Filter group: Small_
* `disableAutoInjectionOfEngagementAttributes` (_boolean_)
If true then this transformer will not auto-inject engagement attributes and instead rely on the HTML providing the attributes using substitution values to provide the data. Default is auto-inject.
_Available in: v66.0_
_Filter group: Small_
* `html` (_string_)
The Handlebars Html Template to be used to transform the content.
_Available in: v66.0_
_Filter group: Small_
* `script` (_string_)
The Handlebars Script Template to be used to transform the content.
_Available in: v66.0_
_Filter group: Small_
### SubstitutionInputDetails
Details for a substitution variable.
* `configType` (_PersonalizationSubstitutionDefConfigTypeEnum_)
* `defaultValue` (_string_) A default value for the substitution definition to be used if Personalization Experience Config does not override the value
* `description` (_string_) Description to be displayed in a UI when configuring this Substitution Variable
* `label` (_string_) Label to be displayed in a UI when configuring this Substitution Variable
* `overridable` (_boolean_) Can the Experience override the default value?
* `required` (_boolean_) Must a value (either default or in Experience) be provided?
### TransformerTypeDetails
Transformer type-specific input for creating or updating a Transformer.
* `html` (_string_)
Handlebars Html Template to be used to transform the content.
_Available in: v66.0_
_Filter group: Small_
* `disableAutoInjectionOfEngagementAttributes` (_boolean_)
If true, this transformer does not auto-inject engagement attributes and relies on the HTML providing the attributes using substitution values. Default is auto-inject.
_Available in: v66.0_
_Filter group: Small_
* `script` (_string_)
Handlebars Script Template to be used to transform the content.
_Available in: v66.0_
_Filter group: Small_
* `componentName` (_string_)
Name the Mobile developer provides to indicate which Component Class in the Application does the rendering. Web version could be the name of a React Component class.
_Available in: v66.0_
_Filter group: Small_
### PersonalizationMergeFieldInput
This representation defines a merge field embedded in a personalization attribute value. Merge fields enable you to embed dynamic data from the profile data graph into personalization content. When using direct attributes, objectName and fieldName are required. When using calculated insights and related attributes, objectName, fieldName, objectPath, sortOrder, and sortByFieldName are required. When using a segment memberships DMO, don't provide values for objectName or fieldName.
* `defaultText` (_string_)
Fallback value if the merge field resource isn't found at runtime.
_Available in: v66.0_
* `fieldName` (_string_)
The API name of the field on the DMO. Required for DirectAttribute, CalculatedInsight, and RelatedAttribute.
_Available in: v67.0_
* `name` (_string_)
The API name of the merge field.
_Available in: v66.0_
* `objectName` (_string_)
The API name of the DMO. Required for DirectAttribute, CalculatedInsight, and RelatedAttribute.
_Available in: v67.0_
* `objectPath` (_array of string_)
Path in the data graph from the root DMO to the referenced DMO (for objectName).
_Available in: v67.0_
* `sortByFieldName` (_string_)
The field to sort by when a merge field resolves to more than one value.
_Available in: v67.0_
* `resourceType` (_object_)
The type of resource this merge field references.
_Available in: v66.0_
Includes all fields of `MergeFieldResourceTypeEnum`.
* `sortOrder` (_object_)
Sort order when the merge field resolves to more than one value.
_Available in: v67.0_
Includes all fields of `MergeFieldSortOrderEnum`.
### PersonalizationAttributeEnum
Standard Personalization Schemas Attribute
Type: `string`.
Allowed values: `FlowPath`, `Variation`.
### MetricTypeEnum
Enum values for the different types of enums supported by experimentation
Type: `string`.
Allowed values: `EngagementSignal`, `EngagementSignalCompound`.
### PersonalizationAttributeValue
Contains detailed output information for an attribute value.
* `attributeName` (_string_)
API name of the custom attribute.
_Available in: v61.0_
* `mergeFields` (_array of PersonalizationMergeField_)
List of merge fields embedded in this attribute value.
_Available in: v66.0_
* `value` (_string_)
The value of the attribute.
_Available in: v61.0_
* `attributeEnum` (_object_)
Standard attribute set.
_Available in: v61.0_
Includes all fields of `PersonalizationAttributeEnum`.
### Filter
Filter parameter for object search.
* `aggregateFunction` (_string_) Aggregate Function
* `comparison` (_Filter_)
* `daysOfTheWeek` (_array of DayOfWeekEnum_) Days of the Week
* `filter` (_FiltersWrap_)
* `filters` (_array of Filter_)
Filters
_This property is recursive: each item has the same structure as `Filter`._
* `firstBoundValue` (_number (double)_) First Bound Value
* `metric` (_Subject_)
* `operator` (_string_)
Filter operator. Values are:
* `EqOp` —Equal
* `ExcludesOp` —Excludes
* `GtOp` —Greater than
* `GteOp` —Greater than or equal
* `InOp` —In
* `IncludesOp` —Includes
* `LikeOp` —Like
* `LtOp` —Less than
* `LteOp` —Less than or equal
* `NeOp` —Not equal
* `NinOp` —Not in
_Available in: v63.0_
_Filter group: Small_
Allowed values: `EqOp`, `ExcludesOp`, `GtOp`, `GteOp`, `InOp`, `IncludesOp`, `LikeOp`, `LtOp`, `LteOp`, `NeOp`, `NinOp`.
* `path` (_array of array of Subject_) Path
* `ruleTimeZone` (_string_) Rule Time Zone
* `schedulingTimeZone` (_SchedulingTimeZoneEnum_)
* `secondBoundValue` (_number (double)_) Second Bound Value
* `subject` (_Subject_)
* `timeOfDay` (_array of string_) Time of Day
* `type` (_string_) Type
* `value` (_integer_) Value
* `values` (_array of string_)
Filter values.
_Available in: v63.0_
_Filter group: Small_
* `field` (_string_)
Filter field API name.
_Available in: v63.0_
_Filter group: Small_
### PersonalizationExperimentMetricTypeEnumRequest
Specifies the type of entity the metric applies to.
* `EngagementSignal` (_string_) _Available in: v65.0_
* `CompoundEngagementSignal` (_string_) _Available in: v65.0_
### EngagementSignalImpactEnum
Engagement Signal Impact for Calculated Affinity
Type: `string`.
Allowed values: `Negative`, `Positive`.
### EngagementSignalStrengthEnum
Engagement Signal Strength for Calculated Affinity
Type: `string`.
Allowed values: `High`, `Low`, `Medium`.
### ReferenceEnum
Personalization Experience Config Data Provider Reference Type
Type: `string`.
Allowed values: `ApiName`.
### DataProviderGroupByEnum
Personalization Experience Config Data Provider Group By Type
Type: `string`.
Allowed values: `DataGraph`.
### DataProviderEnum
Personalization Experience Config Data Provider Type
Type: `string`.
Allowed values: `PersonalizationPoint`.
### SourceMatcherEnum
Personalization Experience Config Source Matcher Type
Type: `string`.
Allowed values: `ContentZone`, `PageType`, `PageUrlMatcher`.
### TargetMethodEnum
Personalization Experience Config Target Method Type, This currently encompasses both a Where and a How component (for example, ReplaceElementContent, AddAfterElement, AddBeforeElement all deal with Where = Element, and then several How's of :Replace, Add Before, Add After)
Type: `string`.
Allowed values: `AddAfterElement`, `AddBeforeElement`, `AddOverlay`, `ContentZoneHandler`, `ReplaceContentZoneContent`, `ReplaceElementContent`.
### Transformation
Personalization Experience Config Transformation Output Representation
* `name` (_string_) The name of the Content Zone.
* `path` (_string_) Path to the Element
* `substitutionValues` (_object_) When a Transformer supports Substitution Definitions, then this will be the mapping of the Value to the Definition. The Data Type of the Value will need to conform to the Definition's Data Type.
Additional properties: `object`.
* `tag` (_string_) The tag of element (e.g. div, img, etc.)
* `transformerName` (_string_) The name of the transformer to use for the transformation.
### TransformationConfigWhenEnum
Personalization Experience Config Transformation Config When Type
Type: `string`.
Allowed values: `ElementClick`, `ExitIntent`, `Immediately`, `ScrollPercent`.
### WhenValues
Personalization Experience Config When Values Output Representation
* `delay` (_integer_) Delay in milliseconds where number is 0 or greater
* `path` (_string_) Path to the Element
* `percent` (_number (double)_) Scroll Percentage as a decimal between 0 and 1
* `tag` (_string_) The tag of element (e.g. div, img, etc.)
### DecisionStateEnum
Decision lifecycle state
Type: `string`.
Allowed values: `Draft`, `Live`.
### RuleTypeEnum
Rule Type
Type: `string`.
Allowed values: `CalculatedInsight`, `Field`, `Group`, `RelatedField`.
### PersonalizationRecommenderSortOrderEnumRequest
Defines the allowed sort order values.
* `Asc` (_string_)
Sort results in ascending order.
_Available in: v64.0_
* `Desc` (_string_)
Sort results in descending order.
_Available in: v64.0_
### LogicalOperatorEnum
Logical Operator
Type: `string`.
Allowed values: `And`, `Or`.
### BaseRule
The information about a single filter condition of the recommender.
* `type` (_RuleTypeEnum_)
### SortOrderEnum
Order for sorting.
Type: `string`.
Allowed values: `Ascending`, `Descending`.
### PersonalizationRecommenderJobStatusEnum
Enum values for “COMPLETE”, “PROCESSING”, “FAILURE” and “CANCELED” for a recommender job status.
Type: `string`.
Allowed values: `Canceled`, `Complete`, `Failure`, `Processing`.
### PersonalizationContentObjectField
Personalization Content Object Field Output Representation
* `label` (_string_) Personalization base output label
* `name` (_string_) Personalization base output API name
### EngagementSignalFilterGroupConditionEnum
Operator to combine the filters in this group. The value can be
_Available in: v63.0_
Type: `string`.
Allowed values: `And`, `Or`.
### EngagementSignalFilterInput
Filter used within an Engagement Signal filter group.
* `action` (_object_, required)
EngagementSignalFilterActionEnum
Filter action. The value can be
_Available in: v63.0_
Includes all fields of `EngagementSignalFilterActionEnum`.
* `field` (_object_, required)
EngagementSignalField
A field on the content object DMO or its related DMO.
_Available in: v63.0_
Includes all fields of `EngagementSignalField`.
* `operator` (_object_, required)
EngagementSignalFilterOperatorEnum
Comparison operator. The value can be
_Available in: v63.0_
Includes all fields of `EngagementSignalFilterOperatorEnum`.
* `values` (_array of string_, required)
List of values.
_Available in: v63.0_
### EngagementSignalFilterOperatorEnum
Filter operator for the parameter. The value can be
_Available in: v63.0_
Type: `string`.
Allowed values: `Equals`, `GreaterThan`, `GreaterThanOrEqual`, `HasNoValue`, `HasValue`, `LessThan`, `LessThanOrEqual`, `NotEquals`.
### EngagementSignalFilter
Engagement Signal Filter output representation
* `action` (_EngagementSignalFilterActionEnum_)
* `field` (_Field_)
* `operator` (_EngagementSignalFilterOperatorEnum_)
* `values` (_array of string_) Engagement Signal Filter Values
### Relationship
Output representation for a relationship
* `cardinality` (_string_) Cardinality of the relationship
* `relationshipId` (_string_) FieldSrcTrgtRelationship ID
* `sourceField` (_Field_)
* `targetField` (_Field_)
### PersonalizationSubstitutionDefConfigTypeEnum
Specifies how the substitution variable can be interpreted. Values are: `{SchemaPath}` , `{Static}` .
_Available in: v66.0_
_Filter group: Small_
Type: `string`.
Allowed values: `SchemaPath`, `Static`.
### MergeFieldResourceTypeEnum
Merge Field Resource Type
Type: `string`.
Allowed values: `CalculatedInsight`, `DirectAttribute`, `RelatedAttribute`, `SegmentMembershipsDmo`.
### MergeFieldSortOrderEnum
Order for sorting. One of these values:
* `Ascending`: Items are in ascending alphabetical order (A-Z).
* `Descending`: Items are in descending alphabetical order (Z-A).
Type: `string`.
Allowed values: `Ascending`, `Descending`.
### PersonalizationMergeField
Contains detailed output information for a personalization merge field.
* `defaultText` (_string_)
Fallback value if the resource is not found.
_Available in: v66.0_
* `fieldName` (_string_)
The API name of the field on the Data Model Object.
_Available in: v67.0_
* `name` (_string_)
The API name of the merge field.
_Available in: v66.0_
* `objectName` (_string_)
The API name of the Data Model Object.
_Available in: v67.0_
* `objectPath` (_array of string_)
Path from root DMO to the referenced DMO.
_Available in: v67.0_
* `sortByFieldName` (_string_)
Field to sort by for multi-value resolution.
_Available in: v67.0_
* `resourceType` (_object_)
The type of resource.
_Available in: v66.0_
Includes all fields of `MergeFieldResourceTypeEnum`.
* `sortOrder` (_object_)
Sort order for multi-value resolution.
_Available in: v67.0_
Includes all fields of `MergeFieldSortOrderEnum`.
### DayOfWeekEnum
Enum values for day of week of a Scheduling targeting rule.
Type: `string`.
Allowed values: `Friday`, `Monday`, `Saturday`, `Sunday`, `Thursday`, `Tuesday`, `Wednesday`.
### FiltersWrap
Personalization Decision Criteria Filters Wrap Output Representation
* `filters` (_array of Filter_) Filters
* `operator` (_string_) Operator
* `type` (_string_) Type
### Subject
Personalization Decision Criteria Subject Output Representation
* `fieldApiName` (_string_) Field API Name
* `fieldLabel` (_string_) Field Label
* `objectApiName` (_string_) Object API Name
* `objectLabel` (_string_) Object Label
### SchedulingTimeZoneEnum
Enum values for “organization” and “recipient” for the timezone of a Scheduling targeting rule.
Type: `string`.
Allowed values: `Organization`, `Recipient`.
### EngagementSignalFilterActionEnum
Enum values for “includes” and “excludes” for a Engagement signal filter action.
Type: `string`.
Allowed values: `Excludes`, `Includes`.
### BaseMetricReferenceInput
A reference to a metric used in Input Representations
* `engagementSignalName` (_string_) Developer name of the metric’s parent
* `higherIsBetter` (_boolean_) Indicates whether a higher value for the metric is better
* `metricName` (_string_) Developer name of the metric
* `metricType` (_MetricTypeEnum_)
### PersonalizationPaginatedResponseBase
Base paginated response representation
* `currentPageUrl` (_string (url)_) Current page url
* `nextPageUrl` (_string (url)_) Next page url if it exists
* `totalSize` (_integer_) Total size of collection
### PersonalizationNamedBase
Personalization Base Output Representation
* `createdById` (_string (Id)_) Created by id
* `createdDate` (_string (date-time)_) Created date
* `id` (_string (Id)_) The 18 character ID of the record
* `label` (_string_) Personalization base output label
* `lastModifiedById` (_string (Id)_) Last modified by id
* `lastModifiedDate` (_string (date-time)_) Last modified date
* `name` (_string_) Personalization base output API name
* `url` (_string (url)_) Url
### PersonalizationBaseInput
Personalization Base Input Representation
* `description` (_string_) Personalization Base description
* `label` (_string_) Personalization Base label
* `name` (_string_) Personalization Point API name
### BaseMetricReference
A reference to a metric used in Output Representations
* `engagementSignalName` (_string_) Developer name of the metric’s parent
* `higherIsBetter` (_boolean_) Indicates whether a higher value for the metric is better
* `metricName` (_string_) Developer name of the metric
* `metricType` (_MetricTypeEnum_)
### PersonalizationBasePatchInput
Personalization Base Patch Input Representation
* `description` (_string_) Description of the entity.
* `label` (_string_) Label of the entity.
### Base
Base class for output representations with common fields
* `createdById` (_string_)
ID of the user or process that created this object.
_Available in: v66.0_
_Filter group: Small_
* `createdDate` (_string (date-time)_)
Timestamp when the object was created.
_Available in: v66.0_
_Filter group: Small_
* `description` (_string_)
Description of the object.
_Available in: v66.0_
_Filter group: Small_
* `id` (_string_)
Unique identifier for the object.
_Available in: v66.0_
_Filter group: Small_
* `label` (_string_)
Human-readable label or title for the object.
_Available in: v66.0_
_Filter group: Small_
* `lastModifiedById` (_string_)
ID of the user or process that last modified this object.
_Available in: v66.0_
_Filter group: Small_
* `lastModifiedDate` (_string (date-time)_)
Timestamp of the most recent update to the object.
_Available in: v66.0_
_Filter group: Small_
* `name` (_string_)
Internal name of the object.
_Available in: v66.0_
_Filter group: Small_
### BaseInput
Base class for input representations with common fields
* `description` (_string_)
Description of the object.
_Available in: v66.0_
* `label` (_string_)
Human-readable label or title for the object.
_Available in: v66.0_
* `name` (_string_)
Unique name of the object.
_Available in: v66.0_
# Prerequisites
Complete these prerequisites before you begin the quick start.
Become familiar with:
- cURL, which is a command-line tool the quick start uses as the client application that makes HTTP requests to Salesforce.
- JavaScript Object Notation (JSON), which is the data format returned in this quick start.
- OAuth 2.0, which is the framework Salesforce uses for authentication. The quick start provides the steps, but it would be helpful to familiarize yourself with OAuth terms and concepts.
# Recommendations
Salesforce provides several types of recommendations, and Connect REST API supports Einstein Next Best Action, custom recommendations for Experience Cloud sites, and Chatter recommendations.
## Einstein Next Best Action
Einstein Next Best Action lets you use strategies to recommend actions and offers. You can deliver the right recommendation at the right moment to the right person. Integrate business rules, predictive models, and data—both inside and outside of Salesforce—to create unique strategies for all your use cases.
[...]
